# This file was auto-generated by Fern from our API Definition.

from ..core.client_wrapper import SyncClientWrapper
from .raw_client import RawLaborClient
from .break_types.client import BreakTypesClient
from .employee_wages.client import EmployeeWagesClient
from .shifts.client import ShiftsClient
from .team_member_wages.client import TeamMemberWagesClient
from .workweek_configs.client import WorkweekConfigsClient
from ..core.client_wrapper import AsyncClientWrapper
from .raw_client import AsyncRawLaborClient
from .break_types.client import AsyncBreakTypesClient
from .employee_wages.client import AsyncEmployeeWagesClient
from .shifts.client import AsyncShiftsClient
from .team_member_wages.client import AsyncTeamMemberWagesClient
from .workweek_configs.client import AsyncWorkweekConfigsClient


class LaborClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawLaborClient(client_wrapper=client_wrapper)
        self.break_types = BreakTypesClient(client_wrapper=client_wrapper)

        self.employee_wages = EmployeeWagesClient(client_wrapper=client_wrapper)

        self.shifts = ShiftsClient(client_wrapper=client_wrapper)

        self.team_member_wages = TeamMemberWagesClient(client_wrapper=client_wrapper)

        self.workweek_configs = WorkweekConfigsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawLaborClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawLaborClient
        """
        return self._raw_client


class AsyncLaborClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawLaborClient(client_wrapper=client_wrapper)
        self.break_types = AsyncBreakTypesClient(client_wrapper=client_wrapper)

        self.employee_wages = AsyncEmployeeWagesClient(client_wrapper=client_wrapper)

        self.shifts = AsyncShiftsClient(client_wrapper=client_wrapper)

        self.team_member_wages = AsyncTeamMemberWagesClient(client_wrapper=client_wrapper)

        self.workweek_configs = AsyncWorkweekConfigsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawLaborClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawLaborClient
        """
        return self._raw_client
